## vtk9 9.1.0+really9.1.0+dfsg2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...3.16 FATAL_ERROR)

project(VTK)

if (POLICY CMP0127)
  cmake_policy(SET CMP0127 NEW) # cmake_dependent_option changes
endif ()

set(vtk_cmake_dir "${VTK_SOURCE_DIR}/CMake")
list(INSERT CMAKE_MODULE_PATH 0 "${vtk_cmake_dir}")

if (APPLE)
  include(vtkApple)
endif ()

# must be before the following iOS / Android
find_package(Git QUIET)
include(VTKDetermineVersion)
include(vtkVersion)
set(VTK_VERSION
    "${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}.${VTK_BUILD_VERSION}")
determine_version("${CMAKE_CURRENT_SOURCE_DIR}" "${GIT_EXECUTABLE}" "VTK")

option(VTK_IOS_BUILD "Build vtk.framework for iOS" OFF)
mark_as_advanced(VTK_IOS_BUILD)
if (VTK_IOS_BUILD)
  include(vtkiOS)
  return()
endif()

option(VTK_ANDROID_BUILD "Build VTK for Android" OFF)
mark_as_advanced(VTK_ANDROID_BUILD)
if (VTK_ANDROID_BUILD)
  include(vtkAndroid)
  return()
endif()

include(vtkCMakeBackports)

option(VTK_WHEEL_BUILD "Build in such a way that Python wheels are supported" OFF)
mark_as_advanced(VTK_WHEEL_BUILD)
if (VTK_WHEEL_BUILD)
  include(vtkWheelPreparation)
endif ()

include(GNUInstallDirs)

add_library(vtkbuild INTERFACE)
add_library(VTK::vtkbuild ALIAS vtkbuild)

include(vtkCompilerChecks)
include(vtkCompilerPlatformFlags)
include(vtkCompilerExtraFlags)
include(vtkInitializeBuildType)
include(vtkSupportMacros)
include(vtkDownload)
include(vtkSanitize)
include(vtkTesting)
include(vtkMobileDevices)
include(vtkWrapSettings)
include(vtkCrossCompiling)
include(vtkObjectFactory)

option(VTK_RELOCATABLE_INSTALL "Do not embed hard-coded paths into the install" ON)
mark_as_advanced(VTK_RELOCATABLE_INSTALL)
cmake_dependent_option(VTK_UNIFIED_INSTALL_TREE "Assume that the install tree contains all of VTK's dependencies" OFF
  VTK_RELOCATABLE_INSTALL OFF)
mark_as_advanced(VTK_UNIFIED_INSTALL_TREE)

set(CMAKE_INSTALL_LICENSEDIR ""
  CACHE STRING "License files (DATAROOTDIR/licenses/${CMAKE_PROJECT_NAME}")
mark_as_advanced(CMAKE_INSTALL_LICENSEDIR)
if (NOT CMAKE_INSTALL_LICENSEDIR)
  set(CMAKE_INSTALL_LICENSEDIR
    "${CMAKE_INSTALL_DATAROOTDIR}/licenses/${CMAKE_PROJECT_NAME}")
endif ()

set(CMAKE_INSTALL_QMLDIR ""
  CACHE PATH "QML files (LIBDIR/qml)")
mark_as_advanced(CMAKE_INSTALL_QMLDIR)
if (NOT CMAKE_INSTALL_QMLDIR)
  set(CMAKE_INSTALL_QMLDIR
    "${CMAKE_INSTALL_LIBDIR}/qml")
endif ()

set(VTK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})
set(CMAKE_CXX_VISIBILITY_PRESET "hidden")
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)

#-----------------------------------------------------------------------------
# Add the Remote Subdirectory
if (VTK_ENABLE_REMOTE_MODULES)
  add_subdirectory(Remote)
endif ()

#-----------------------------------------------------------------------------
# Does VTK require support for 64 bit file systems
include(CheckCXXSourceRuns)
file(READ "${vtk_cmake_dir}/vtkRequireLargeFilesSupport.cxx"
  VTK_REQUIRE_LARGE_FILE_SUPPORT_FILE)
check_cxx_source_runs("${VTK_REQUIRE_LARGE_FILE_SUPPORT_FILE}"
  VTK_REQUIRE_LARGE_FILE_SUPPORT)

#-----------------------------------------------------------------------------
# Provide compatibility options.
option(VTK_LEGACY_REMOVE "Remove all legacy code completely." OFF)
option(VTK_LEGACY_SILENT "Silence all legacy code messages." OFF)
mark_as_advanced(VTK_LEGACY_REMOVE VTK_LEGACY_SILENT)

# Tell VTK source files they are being built inside VTK.
add_definitions(-DVTK_IN_VTK)

include(CheckTypeSize)

option(VTK_USE_MPI "Support MPI" OFF)

option(VTK_SERIAL_TESTS_USE_MPIEXEC "Used on HPC to run serial tests on compute nodes" OFF)
mark_as_advanced(VTK_SERIAL_TESTS_USE_MPIEXEC)

#-----------------------------------------------------------------------------
# Add an option to enable memkind
if (UNIX AND NOT APPLE)
  option(VTK_USE_MEMKIND "Build support for extended memory" OFF)
endif()

#-----------------------------------------------------------------------------
# Add an option to enable/disable components that have CUDA.
option(VTK_USE_CUDA "Support CUDA compilation" OFF)
if(VTK_USE_CUDA)
  # This needs to be a top level flag as enable_language needs
  # to be called from CMake entry point for variables to have
  # the correct scope.
  enable_language(CUDA)
endif()

#-----------------------------------------------------------------------------
# Add an option to enable/disable logging support.
option(VTK_ENABLE_LOGGING "Enable logging support." ON)
mark_as_advanced(VTK_ENABLE_LOGGING)

include(vtkEncodeString)

# Set up our directory structure for output libraries and binaries
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")

set(vtk_requested_modules)
set(vtk_rejected_modules)
if (VTK_WRAP_PYTHON)
  list(APPEND vtk_requested_modules
    VTK::WrappingPythonCore
    VTK::PythonInterpreter)
  set("_vtk_module_reason_VTK::WrappingPythonCore"
    "via `VTK_WRAP_PYTHON`")
  set("_vtk_module_reason_VTK::PythonInterpreter"
    "via `VTK_WRAP_PYTHON`")
else ()
  list(APPEND vtk_rejected_modules
    VTK::Python)
  set("_vtk_module_reason_VTK::Python"
    "via `VTK_WRAP_PYTHON`")
endif ()
if (VTK_WRAP_JAVA)
  list(APPEND vtk_requested_modules
    VTK::Java)
else ()
  list(APPEND vtk_rejected_modules
    VTK::Java)
endif ()
set("_vtk_module_reason_VTK::Java"
  "via `VTK_WRAP_JAVA`")
# For vtkTkRenderWidget (only useful with Python, since WRAP_TCL is gone)
if (VTK_USE_TK)
  set(VTK_GROUP_ENABLE_Tk YES)
endif ()
if (VTK_USE_MPI)
  set(VTK_GROUP_ENABLE_MPI YES)
else ()
  # Reject `VTK::mpi`, but allow those which happen to be part of the group to
  # be built.
  set(_vtk_module_group_default_MPI "DONT_WANT")
  list(APPEND vtk_rejected_modules
    VTK::mpi)
  set("_vtk_module_reason_VTK::mpi"
    "via `VTK_USE_MPI`")
endif ()
if (VTK_ENABLE_LOGGING)
  list(APPEND vtk_requested_modules
    VTK::loguru)
  set("_vtk_module_reason_VTK::loguru"
    "via `VTK_ENABLE_LOGGING`")
endif ()

if (VTK_BUILD_TESTING)
  list(APPEND vtk_requested_modules
    # Required for just about all VTK tests.
    VTK::TestingCore)
  set("_vtk_module_reason_VTK::TestingCore"
    "via `VTK_BUILD_TESTING`")
endif ()

list(APPEND vtk_requested_modules
  # Required for just about everything.
  VTK::CommonCore
  VTK::CommonDataModel)
set("_vtk_module_reason_VTK::CommonCore"
  "all VTK builds require VTK::CommonCore")
set("_vtk_module_reason_VTK::CommonDataModel"
  "all VTK builds require VTK::CommonDataModel")

if (VTK_ENABLE_WRAPPING)
  list(APPEND vtk_requested_modules
    # Required for wrapping with hierarchy files.
    VTK::WrappingTools)
  set("_vtk_module_reason_VTK::WrappingTools"
    "via `VTK_ENABLE_WRAPPING`")
endif ()

if (vtk_requested_modules)
  list(REMOVE_DUPLICATES vtk_requested_modules)
endif ()
if (vtk_rejected_modules)
  list(REMOVE_DUPLICATES vtk_rejected_modules)
endif ()

set_property(GLOBAL
  PROPERTY
    "_vtk_module_autoinit_include" "\"vtkAutoInit.h\"")

option(VTK_BUILD_ALL_MODULES "Build all modules by default" OFF)
mark_as_advanced(VTK_BUILD_ALL_MODULES)
set(_vtk_module_reason_WANT_BY_DEFAULT
  "via `VTK_BUILD_ALL_MODULES`")

option(VTK_TARGET_SPECIFIC_COMPONENTS "Install files in target-specific components" OFF)
mark_as_advanced(VTK_TARGET_SPECIFIC_COMPONENTS)

# Turn on these groups by default.
set(_vtk_module_group_default_StandAlone "WANT")
set(_vtk_module_group_default_Rendering "WANT")

set(vtk_enable_tests "${VTK_BUILD_TESTING}")
if (VTK_FORBID_DOWNLOADS)
  message(STATUS "Module testing disabled due to `VTK_FORBID_DOWNLOADS` being set.")
  set(vtk_enable_tests "OFF")
endif ()

include(vtkModule)
include(vtkModuleDebugging)
set(vtk_source_directories
  "${CMAKE_CURRENT_SOURCE_DIR}/Accelerators"
  "${CMAKE_CURRENT_SOURCE_DIR}/Charts"
  "${CMAKE_CURRENT_SOURCE_DIR}/Common"
  "${CMAKE_CURRENT_SOURCE_DIR}/Domains"
  "${CMAKE_CURRENT_SOURCE_DIR}/Filters"
  "${CMAKE_CURRENT_SOURCE_DIR}/Geovis"
  "${CMAKE_CURRENT_SOURCE_DIR}/GUISupport"
  "${CMAKE_CURRENT_SOURCE_DIR}/Imaging"
  "${CMAKE_CURRENT_SOURCE_DIR}/Infovis"
  "${CMAKE_CURRENT_SOURCE_DIR}/Interaction"
  "${CMAKE_CURRENT_SOURCE_DIR}/IO"
  "${CMAKE_CURRENT_SOURCE_DIR}/Parallel"
  "${CMAKE_CURRENT_SOURCE_DIR}/Rendering"
  "${CMAKE_CURRENT_SOURCE_DIR}/Testing"
  "${CMAKE_CURRENT_SOURCE_DIR}/ThirdParty"
  "${CMAKE_CURRENT_SOURCE_DIR}/Utilities"
  "${CMAKE_CURRENT_SOURCE_DIR}/Views"
  "${CMAKE_CURRENT_SOURCE_DIR}/Web"
  "${CMAKE_CURRENT_SOURCE_DIR}/Wrapping")

set(remote_default ON)
if (VTK_WHEEL_BUILD)
  set(remote_default OFF)
endif ()
option(VTK_ENABLE_REMOTE_MODULES "Enable remote modules" ON)
mark_as_advanced(VTK_ENABLE_REMOTE_MODULES)
if (VTK_ENABLE_REMOTE_MODULES)
  list(APPEND vtk_source_directories
    "${CMAKE_CURRENT_SOURCE_DIR}/Remote")
endif ()

vtk_module_find_modules(vtk_module_files ${vtk_source_directories})
vtk_module_find_kits(vtk_kit_files ${vtk_source_directories})

# If we're building only the compile tools, limit what is done.
option(VTK_BUILD_COMPILE_TOOLS_ONLY "Build only VTK's compile tools" OFF)
mark_as_advanced(VTK_BUILD_COMPILE_TOOLS_ONLY)
if (VTK_BUILD_COMPILE_TOOLS_ONLY)
  set(vtk_requested_modules
    VTKCompileTools::WrappingTools)
  set(vtk_rejected_modules)
  set(vtk_module_files
    "${CMAKE_CURRENT_SOURCE_DIR}/Wrapping/Tools/vtkcompiletools.module")
  set(vtk_kit_files)
endif ()

cmake_dependent_option(VTK_INSTALL_SDK "Install SDK components" ON
  "NOT VTK_BUILD_COMPILE_TOOLS_ONLY" ON)
mark_as_advanced(VTK_INSTALL_SDK)

vtk_module_scan(
  MODULE_FILES        ${vtk_module_files}
  KIT_FILES           ${vtk_kit_files}
  REQUEST_MODULES     ${vtk_requested_modules}
  REJECT_MODULES      ${vtk_rejected_modules}
  PROVIDES_MODULES    vtk_modules
  PROVIDES_KITS       vtk_kits
  REQUIRES_MODULES    vtk_required_modules
  UNRECOGNIZED_MODULES vtk_unrecognized_modules
  WANT_BY_DEFAULT     "${VTK_BUILD_ALL_MODULES}"
  ENABLE_TESTS        "${vtk_enable_tests}")

if (vtk_required_modules OR vtk_unrecognized_modules)
  message(FATAL_ERROR
    "The following modules were requested or required, but not found: "
    "${vtk_required_modules};${vtk_unrecognized_modules}.")
endif ()

if ("VTK::Python" IN_LIST vtk_modules)
  include(vtkModuleWrapPython)
  if (NOT DEFINED VTK_PYTHON_SITE_PACKAGES_SUFFIX)
    vtk_module_python_default_destination(VTK_PYTHON_SITE_PACKAGES_SUFFIX)
  endif ()
endif ()

cmake_dependent_option(VTK_ENABLE_KITS "Enable kits compilation" OFF
  # Static builds don't make sense with kits. Ignore the flag if shared
  # libraries aren't being built.
  "VTK_BUILD_SHARED_LIBS" OFF)
mark_as_advanced(VTK_ENABLE_KITS)

option(VTK_USE_EXTERNAL "Use external copies of third party libraries by default" OFF)
mark_as_advanced(VTK_USE_EXTERNAL)

option(VTK_VERSIONED_INSTALL "Install artifacts with versioned names." ON)
mark_as_advanced(VTK_VERSIONED_INSTALL)
set(vtk_version_suffix "")
if (VTK_VERSIONED_INSTALL)
  set(vtk_version_suffix "-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}")
endif ()

set(vtk_install_export VTK)
if (NOT DEFINED vtk_cmake_destination)
  set(vtk_cmake_destination
    "${CMAKE_INSTALL_LIBDIR}/cmake/vtk${vtk_version_suffix}")
  set(vtk_target_package)
  if (VTK_BUILD_COMPILE_TOOLS_ONLY)
    set(vtk_install_export VTKCompileTools)
    set(vtk_cmake_destination
      "${CMAKE_INSTALL_LIBDIR}/cmake/vtkcompiletools${vtk_version_suffix}")
    set(vtk_target_package PACKAGE "${vtk_install_export}")
  endif ()
endif ()
install(TARGETS vtkbuild EXPORT "${vtk_install_export}")

set(VTK_CUSTOM_LIBRARY_SUFFIX "<DEFAULT>"
  CACHE STRING "Custom library file name suffix (defaults to the version number)")
mark_as_advanced(VTK_CUSTOM_LIBRARY_SUFFIX)
if (VTK_CUSTOM_LIBRARY_SUFFIX STREQUAL "<DEFAULT>")
  if (VTK_VERSIONED_INSTALL)
    set(VTK_CUSTOM_LIBRARY_SUFFIX "${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}")
  else ()
    set(VTK_CUSTOM_LIBRARY_SUFFIX "")
  endif ()
endif ()

set(vtk_library_version_info

=== Examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...3.16 FATAL_ERROR)
project(VTKExamples)

if (VTK_BINARY_DIR)
  function (add_example dir)
    if (vtk_cmake_build_dir)
      add_test(
        NAME    "VTKExample-${dir}"
        COMMAND "${CMAKE_COMMAND}"
                "-Dconfig=$<CONFIGURATION>"
                "-Dgenerator=${CMAKE_GENERATOR}"
                "-Dsource=${CMAKE_CURRENT_SOURCE_DIR}"
                "-Dbinary=${CMAKE_CURRENT_BINARY_DIR}"
                "-Dexample_dir=${dir}"
                "-Dbuild_type=${CMAKE_BUILD_TYPE}"
                "-Dshared=${BUILD_SHARED_LIBS}"
                "-Dvtk_dir=${vtk_cmake_build_dir}"
                "-Dctest=${CMAKE_CTEST_COMMAND}"
                "-Dplatform=${CMAKE_GENERATOR_PLATFORM}"
                "-Dtoolset=${CMAKE_GENERATOR_TOOLSET}"
                "-Dvtk_binary_dir=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
                -P "${CMAKE_CURRENT_LIST_DIR}/RunExample.cmake")
      set_property(TEST "VTKExample-${dir}" APPEND
        PROPERTY
          SKIP_REGULAR_EXPRESSION "Skipping example")
    endif ()
  endfunction ()
else ()
  macro (add_example dir)
    add_subdirectory("${dir}")
  endmacro ()
endif ()

if (ANDROID)
  #add_example(Android)
elseif (APPLE_IOS)
  #add_example(iOS)
elseif (EMSCRIPTEN)
  if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.13)
    add_example(Emscripten/Cxx/Cone)
    add_example(Emscripten/Cxx/ConeFullScreen)
    add_example(Emscripten/Cxx/MultiCone)
    add_example(Emscripten/Cxx/WrappedMace)
  endif()
else ()
  add_example(AMR/Cxx)
  add_example(Annotation/Cxx/LabeledMesh)
  add_example(Build/vtkMy)
  add_example(Charts/Cxx)
  add_example(DataManipulation/Cxx)
  #add_example(GUI/Cocoa) # xcode project
  add_example(GUI/Qt/FourPaneViewer)
  add_example(GUI/Qt/ImageViewer)
  add_example(GUI/Qt/SimpleView)
  add_example(GUI/Qt/TouchGestureViewer)
  add_example(IO/Cxx)
  add_example(ImageProcessing/Cxx)
  add_example(Infovis/Cxx)
  add_example(Medical/Cxx)
  add_example(Modelling/Cxx)
  add_example(MultiBlock/Cxx)
  add_example(ParallelProcessing/Generic/Cxx)

  add_example(Modules/UsingVTK)
  add_example(Modules/Wrapping)
endif ()

=== Charts/Core/CMakeLists.txt ===
set(classes
  vtkAxis
  vtkAxisExtended
  vtkCategoryLegend
  vtkChart
  vtkChartBox
  vtkChartHistogram2D
  vtkChartLegend
  vtkChartMatrix
  vtkChartParallelCoordinates
  vtkChartPie
  vtkChartXY
  vtkChartXYZ
  vtkColorLegend
  vtkColorTransferControlPointsItem
  vtkColorTransferFunctionItem
  vtkCompositeControlPointsItem
  vtkCompositeTransferFunctionItem
  vtkContextArea
  vtkContextPolygon
  vtkControlPointsItem
  vtkInteractiveArea
  vtkLookupTableItem
  vtkPiecewiseControlPointsItem
  vtkPiecewiseFunctionItem
  vtkPiecewisePointHandleItem
  vtkPlot
  vtkPlot3D
  vtkPlotArea
  vtkPlotBag
  vtkPlotBar
  vtkPlotBarRangeHandlesItem
  vtkPlotBox
  vtkPlotFunctionalBag
  vtkPlotGrid
  vtkPlotHistogram2D
  vtkPlotLine
  vtkPlotLine3D
  vtkPlotParallelCoordinates # This adds a vtkInfovisCore dep for one class...
  vtkPlotPie
  vtkPlotPoints
  vtkPlotPoints3D
  vtkPlotRangeHandlesItem
  vtkPlotStacked
  vtkPlotSurface
  vtkRangeHandlesItem
  vtkScalarsToColorsItem
  vtkScatterPlotMatrix
  )

vtk_module_add_module(VTK::ChartsCore
  CLASSES ${classes})

=== Common/Core/CMakeLists.txt ===
include(CMakeDependentOption)
cmake_dependent_option(VTK_USE_64BIT_TIMESTAMPS "Build VTK with 64 bit timestamps" OFF
  "NOT CMAKE_SIZEOF_VOID_P GREATER 4" ON)
mark_as_advanced(VTK_USE_64BIT_TIMESTAMPS)

if (CMAKE_SIZEOF_VOID_P GREATER 4)
 set(vtk_use_64bit_ids_default ON)
else ()
 set(vtk_use_64bit_ids_default OFF)
endif ()

option(VTK_USE_64BIT_IDS "Build VTK with 64 bit ids" "${vtk_use_64bit_ids_default}")
mark_as_advanced(VTK_USE_64BIT_IDS)

option(VTK_DEBUG_LEAKS "Build leak checking support into VTK." OFF)
mark_as_advanced(VTK_DEBUG_LEAKS)

# See vtkDataArrayRange.h docs for more info on these:
cmake_dependent_option(VTK_DEBUG_RANGE_ITERATORS
  "Detect usage errors with the for-range iterators (SLOW)." OFF
  "CMAKE_BUILD_TYPE STREQUAL \"Debug\"" OFF)
mark_as_advanced(VTK_DEBUG_RANGE_ITERATORS)
cmake_dependent_option(VTK_ALWAYS_OPTIMIZE_ARRAY_ITERATORS
  "Enable additional optimizations for array iterators in Debug builds." OFF
  "NOT VTK_DEBUG_RANGE_ITERATORS" OFF)
mark_as_advanced(VTK_ALWAYS_OPTIMIZE_ARRAY_ITERATORS)

# This option determines the behavior of the New methods of vtkObject derived
# classes. If this option is off then only classes specifically using the
# vtkObjectFactoryNewMacro and vtkAbstractObjectFactoryNewMacro will allow for
# overrides. If the method is on then vtkStandardNewMacro will use the
# vtkObjectFactoryNewMacro's implementation body.
option(VTK_ALL_NEW_OBJECT_FACTORY
  "Build all vtkObject derived classes with object factory new methods." OFF)
mark_as_advanced(VTK_ALL_NEW_OBJECT_FACTORY)

set(vtk_smp_sources)
set(vtk_smp_headers)
set(vtk_smp_nowrap_headers)
set(vtk_smp_templates)
set(vtk_smp_defines)
set(vtk_smp_libraries)
set(vtk_smp_enable_sequential 0)
set(vtk_smp_enable_stdthread 0)
set(vtk_smp_enable_tbb 0)
set(vtk_smp_enable_openmp 0)
set(VTK_SMP_IMPLEMENTATION_TYPE)
include("${CMAKE_CURRENT_SOURCE_DIR}/vtkSMPSelection.cmake")

set(vtk_object_base_defines)

# An optional dependency on memkind
set(vtk_memkind_libraries)
if (VTK_USE_MEMKIND)
  vtk_module_find_package(
    PACKAGE MEMKIND)
  list(APPEND vtk_memkind_libraries
    MEMKIND::MEMKIND)
  get_target_property(memkind_version_minor MEMKIND::MEMKIND MEMKIND_VERSION_MINOR)
  list(APPEND vtk_object_base_defines "MEMKIND_VERSION_MINOR=${memkind_version_minor}")
endif()

# Generate the vtkTypeList_Create macros:
include("${CMAKE_CURRENT_SOURCE_DIR}/vtkCreateTypeListMacros.cmake")
CreateTypeListMacros(
  VTK_TYPELISTMACRO_HEADER_CONTENTS
  99
  vtkTypeList_Create
  "vtkTypeList::TypeList"
  "vtkTypeList::NullType")
configure_file(vtkTypeListMacros.h.in vtkTypeListMacros.h)

# And the ArrayDispatch array list header:
option(VTK_DISPATCH_AOS_ARRAYS "Include array-of-structs vtkDataArray subclasses in dispatcher." ON)
option(VTK_DISPATCH_SOA_ARRAYS "Include struct-of-arrays vtkDataArray subclasses in dispatcher." OFF)
option(VTK_DISPATCH_TYPED_ARRAYS "Include vtkTypedDataArray subclasses (e.g. old mapped arrays) in dispatcher." OFF)
option(VTK_WARN_ON_DISPATCH_FAILURE "If enabled, vtkArrayDispatch will print a warning when a dispatch fails." OFF)
mark_as_advanced(
  VTK_DISPATCH_AOS_ARRAYS
  VTK_DISPATCH_SOA_ARRAYS
  VTK_DISPATCH_TYPED_ARRAYS
  VTK_WARN_ON_DISPATCH_FAILURE)

option(VTK_BUILD_SCALED_SOA_ARRAYS "Include struct-of-arrays with scaled vtkDataArray implementation." OFF)

include("${CMAKE_CURRENT_SOURCE_DIR}/vtkCreateArrayDispatchArrayList.cmake")
vtkArrayDispatch_default_array_setup()
vtkArrayDispatch_generate_array_header(VTK_ARRAYDISPATCH_ARRAY_LIST)
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkArrayDispatchArrayList.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkArrayDispatchArrayList.h"
  @ONLY)

# create a list of source files for explicit array type instantiations
set(instantiation_sources)

# steal the list of array types from vtkCreateArrayDispatchArrayList.cmake
foreach (INSTANTIATION_VALUE_TYPE IN LISTS vtkArrayDispatch_all_types)
  # only instantiate fundamental types, not typedefs
  if (INSTANTIATION_VALUE_TYPE STREQUAL "vtkIdType")
    continue()
  endif ()
  # create a file suffix from the type
  string(REPLACE " " "_" _suffix "${INSTANTIATION_VALUE_TYPE}")

  set(_list "vtkSOADataArrayTemplateInstantiate")
  if (VTK_BUILD_SCALED_SOA_ARRAYS)
    list(APPEND _list "vtkScaledSOADataArrayTemplateInstantiate")
  endif ()
  # see comments in vtkGenericDataArray.h for explanation
  if (INSTANTIATION_VALUE_TYPE MATCHES "(^| )long( |$)")
    list(APPEND _list "vtkGenericDataArrayValueRangeInstantiate")
  endif ()

  # generate cxx file to instantiate template with this type
  foreach (_prefix IN LISTS _list)
    configure_file(
      "${CMAKE_CURRENT_SOURCE_DIR}/${_prefix}.cxx.in"
      "${CMAKE_CURRENT_BINARY_DIR}/${_prefix}_${_suffix}.cxx"
      @ONLY)
    list(APPEND instantiation_sources
      "${CMAKE_CURRENT_BINARY_DIR}/${_prefix}_${_suffix}.cxx")
  endforeach ()
endforeach ()

set(classes
  vtkAbstractArray
  vtkAnimationCue
  vtkArchiver
  vtkArray
  vtkArrayCoordinates
  vtkArrayExtents
  vtkArrayExtentsList
  vtkArrayIterator
  vtkArrayRange
  vtkArraySort
  vtkArrayWeights
  vtkBitArray
  vtkBitArrayIterator
  vtkBoxMuellerRandomSequence
  vtkBreakPoint
  vtkByteSwap
  vtkCallbackCommand
  vtkCharArray
  vtkCollection
  vtkCollectionIterator
  vtkCommand
  vtkCommonInformationKeyManager
  vtkDataArray
  vtkDataArrayCollection
  vtkDataArrayCollectionIterator
  vtkDataArraySelection
  vtkDebugLeaks
  vtkDebugLeaksManager
  vtkDoubleArray
  vtkDynamicLoader
  vtkEventForwarderCommand
  vtkFileOutputWindow
  vtkFloatArray
  vtkFloatingPointExceptions
  vtkGarbageCollector
  vtkGarbageCollectorManager
  vtkGaussianRandomSequence
  vtkIdList
  vtkIdListCollection
  vtkIdTypeArray
  vtkIndent
  vtkInformation
  vtkInformationDataObjectKey
  vtkInformationDoubleKey
  vtkInformationDoubleVectorKey
  vtkInformationIdTypeKey
  vtkInformationInformationKey
  vtkInformationInformationVectorKey
  vtkInformationIntegerKey
  vtkInformationIntegerPointerKey
  vtkInformationIntegerVectorKey
  vtkInformationIterator
  vtkInformationKey
  vtkInformationKeyLookup
  vtkInformationKeyVectorKey
  vtkInformationObjectBaseKey
  vtkInformationObjectBaseVectorKey
  vtkInformationRequestKey
  vtkInformationStringKey
  vtkInformationStringVectorKey
  vtkInformationUnsignedLongKey
  vtkInformationVariantKey
  vtkInformationVariantVectorKey
  vtkInformationVector
  vtkIntArray
  vtkLargeInteger
  vtkLogger
  vtkLongArray
  vtkLongLongArray
  vtkLookupTable
  vtkMath
  vtkMersenneTwister
  vtkMinimalStandardRandomSequence
  vtkMultiThreader
  vtkOStrStreamWrapper
  vtkOStreamWrapper
  vtkObject
  vtkObjectBase
  vtkObjectFactory
  vtkObjectFactoryCollection
  vtkOldStyleCallbackCommand
  vtkOutputWindow
  vtkOverrideInformation
  vtkOverrideInformationCollection
  vtkPoints
  vtkPoints2D
  vtkPriorityQueue
  vtkRandomPool
  vtkRandomSequence
  vtkReferenceCount
  vtkScalarsToColors
  vtkShortArray
  vtkSignedCharArray
  vtkSmartPointerBase
  vtkSortDataArray
  vtkStdString
  vtkStringArray
  vtkStringOutputWindow
  vtkTimePointUtility
  vtkTimeStamp
  vtkUnicodeString
  vtkUnicodeStringArray
  vtkUnsignedCharArray
  vtkUnsignedIntArray
  vtkUnsignedLongArray
  vtkUnsignedLongLongArray
  vtkUnsignedShortArray
  vtkVariant
  vtkVariantArray
  vtkVersion
  vtkVoidArray
  vtkWeakPointerBase
  vtkWeakReference
  vtkWindow
  vtkXMLFileOutputWindow

  # These classes are deprecated.
  vtkConditionVariable
  vtkCriticalSection
  vtkSimpleCriticalSection
  vtkMutexLock)

set(template_classes
  vtkAOSDataArrayTemplate
  vtkArrayDispatch
  vtkArrayInterpolate
  vtkArrayIteratorTemplate
  vtkArrayPrint
  vtkDenseArray
  vtkGenericDataArray
  vtkMappedDataArray
  vtkSOADataArrayTemplate
  vtkSparseArray
  vtkTypedArray
  vtkTypedDataArray
  vtkTypeList)

set(sources
  vtkArrayIteratorTemplateInstantiate.cxx
  vtkGenericDataArray.cxx
  # A separate file that hides some deprecated usages from headers to avoid
  # spamming users of `vtkVariant*.h` headers with noisy warnings. Remove with
  # `VTK_DEPRECATED_IN_9_1_0()`.
  vtkVariantCast.cxx
  ${instantiation_sources}
  ${vtk_smp_sources})

if (VTK_BUILD_SCALED_SOA_ARRAYS)
  list (APPEND template_classes vtkScaledSOADataArrayTemplate)
  set(VTK_USE_SCALED_SOA_ARRAYS 1)
endif ()
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkVTK_USE_SCALED_SOA_ARRAYS.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkVTK_USE_SCALED_SOA_ARRAYS.h")

set(headers
  vtkABI.h
  vtkArrayIteratorIncludes.h
  vtkAssume.h
  vtkAutoInit.h
  vtkBuffer.h
  vtkCollectionRange.h
  vtkCompiler.h
  vtkDataArrayAccessor.h
  vtkDataArrayIteratorMacro.h
  vtkDataArrayMeta.h
  vtkDataArrayRange.h
  vtkDataArrayTupleRange_AOS.h
  vtkDataArrayTupleRange_Generic.h
  vtkDataArrayValueRange_AOS.h
  vtkDataArrayValueRange_Generic.h
  vtkDeprecation.h
  vtkEventData.h
  vtkGenericDataArrayLookupHelper.h
  vtkIOStream.h
  vtkIOStreamFwd.h
  vtkInformationInternals.h
  vtkMathUtilities.h
  vtkMatrixUtilities.h
  vtkMeta.h
  vtkNew.h
  vtkRange.h
  vtkRangeIterableTraits.h
  vtkSetGet.h
  vtkSmartPointer.h
  vtkSystemIncludes.h
  vtkTemplateAliasMacro.h
  vtkTestDataArray.h
  vtkType.h
  vtkTypeTraits.h
  vtkTypedDataArrayIterator.h
  vtkVariantCast.h
  vtkVariantCreate.h
  vtkVariantExtract.h
  vtkVariantInlineOperators.h
  vtkWeakPointer.h
  vtkWin32Header.h
  vtkWindows.h
  vtkWrappingHints.h
  ${vtk_smp_headers}
  "${CMAKE_CURRENT_BINARY_DIR}/vtkArrayDispatchArrayList.h"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkMathConfigure.h"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkTypeListMacros.h"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkVTK_USE_SCALED_SOA_ARRAYS.h")

set(private_headers
  "${CMAKE_CURRENT_BINARY_DIR}/vtkFloatingPointExceptionsConfigure.h")

set(templates
  vtkArrayIteratorTemplateImplicit.txx
  ${vtk_smp_templates})

set(private_templates
  vtkDataArrayPrivate.txx)

set(vtk_include_dirs)

vtk_module_find_package(
  PACKAGE Threads)

set(VTK_MAX_THREADS "64" CACHE STRING
  "Max number of threads vtkMultiThreader will allocate.")
mark_as_advanced(VTK_MAX_THREADS)

if (CMAKE_USE_PTHREADS_INIT AND CMAKE_USE_WIN32_THREADS_INIT)
  if (DEFINED _vtk_thread_impl_output)
    set(thread_impl_output "${_vtk_thread_impl_output}")
  else ()
    execute_process(
      COMMAND "${CMAKE_C_COMPILER}" -v
      OUTPUT_VARIABLE thread_impl_output
      ERROR_VARIABLE  thread_impl_output
      RESULT_VARIABLE result
      TIMEOUT         10)
    if (result)
      message(FATAL_ERROR
        "Failed to determine the thread implementation in use by the "
        "compiler.")
    endif ()
    string (REGEX REPLACE ".*Thread model: \((posix|win32)\).*" "\\1" thread_impl_output "${thread_impl_output}")
  endif ()
  set(_vtk_thread_impl_output "${thread_impl_output}"
    CACHE INTERNAL "thread model detection")
  if (thread_impl_output MATCHES "posix")
    set(VTK_USE_PTHREADS 1)
  elseif (thread_impl_output MATCHES "win32")
    set(VTK_USE_WIN32_THREADS 1)
  else ()
    set(VTK_USE_PTHREADS 1)
  endif ()
elseif (CMAKE_USE_PTHREADS_INIT)
  set(VTK_USE_PTHREADS 1)
elseif (CMAKE_USE_WIN32_THREADS_INIT)
  set(VTK_USE_WIN32_THREADS 1)
endif ()

# We can't check for the target since we're before VTK::CommonDataModel in the
# dependency graph.
if (VTK_MODULE_ENABLE_VTK_CommonDataModel)
  list(APPEND vtk_include_dirs
    "${CMAKE_CURRENT_BINARY_DIR}/../DataModel")
  set_property(SOURCE vtkInformationDataObjectKey.cxx
    PROPERTY
      COMPILE_DEFINITIONS vtkCommonDataModel_ENABLED)
endif ()

if(WIN32)
  list(APPEND classes
    vtkWin32OutputWindow
    vtkWin32ProcessOutputWindow)
  list(APPEND sources
    vtkWin32OutputWindowProcessEncoded.c)
endif()

if(ANDROID)
  list(APPEND classes
    vtkAndroidOutputWindow)
endif()

# Platform configuration tests.
include(TestBigEndian)
test_big_endian(VTK_WORDS_BIGENDIAN)

# vtkSMP header information.
set(smp_backends
  OpenMP
  Sequential
  STDThread
  TBB)
foreach (smp_backend IN LISTS smp_backends)
  string(TOLOWER "${smp_backend}" smp_backend_lower)
  string(TOUPPER "${smp_backend}" smp_backend_upper)

=== Common/DataModel/CMakeLists.txt ===
set(classes
  vtkAMRBox
  vtkAMRUtilities
  vtkAbstractCellLinks
  vtkAbstractCellLocator
  vtkAbstractElectronicData
  vtkAbstractPointLocator
  vtkAdjacentVertexIterator
  vtkAnimationScene
  vtkAnnotation
  vtkAnnotationLayers
  vtkArrayData
  vtkAtom
  vtkAttributesErrorMetric
  vtkBSPCuts
  vtkBSPIntersections
  vtkBezierCurve
  vtkBezierHexahedron
  vtkBezierInterpolation
  vtkBezierQuadrilateral
  vtkBezierTetra
  vtkBezierTriangle
  vtkBezierWedge
  vtkBiQuadraticQuad
  vtkBiQuadraticQuadraticHexahedron
  vtkBiQuadraticQuadraticWedge
  vtkBiQuadraticTriangle
  vtkBond
  vtkBoundingBox
  vtkBox
  vtkCell
  vtkCell3D
  vtkCellArray
  vtkCellArrayIterator
  vtkCellData
  vtkCellIterator
  vtkCellLinks
  vtkCellLocator
  vtkCellLocatorStrategy
  vtkCellTypes
  vtkClosestNPointsStrategy
  vtkClosestPointStrategy
  vtkCompositeDataIterator
  vtkCompositeDataSet
  vtkCone
  vtkConvexPointSet
  vtkCubicLine
  vtkCylinder
  vtkDataAssembly
  vtkDataAssemblyUtilities
  vtkDataObject
  vtkDataObjectCollection
  vtkDataObjectTree
  vtkDataObjectTreeIterator
  vtkDataObjectTypes
  vtkDataSet
  vtkDataSetAttributes
  vtkDataSetAttributesFieldList
  vtkDataSetCellIterator
  vtkDataSetCollection
  vtkDirectedAcyclicGraph
  vtkDirectedGraph
  vtkDistributedGraphHelper
  vtkEdgeListIterator
  vtkEdgeTable
  vtkEmptyCell
  vtkExplicitStructuredGrid
  vtkExtractStructuredGridHelper
  vtkFieldData
  vtkFindCellStrategy
  vtkGenericAdaptorCell
  vtkGenericAttribute
  vtkGenericAttributeCollection
  vtkGenericCell
  vtkGenericCellIterator
  vtkGenericCellTessellator
  vtkGenericDataSet
  vtkGenericEdgeTable
  vtkGenericInterpolatedVelocityField
  vtkGenericPointIterator
  vtkGenericSubdivisionErrorMetric
  vtkGeometricErrorMetric
  vtkGraph
  vtkGraphEdge
  vtkGraphInternals
  vtkHexagonalPrism
  vtkHexahedron
  vtkHierarchicalBoxDataIterator
  vtkHierarchicalBoxDataSet
  vtkHigherOrderCurve
  vtkHigherOrderHexahedron
  vtkHigherOrderInterpolation
  vtkHigherOrderQuadrilateral
  vtkHigherOrderTetra
  vtkHigherOrderTriangle
  vtkHigherOrderWedge
  vtkHyperTree
  vtkHyperTreeCursor
  vtkHyperTreeGrid
  vtkHyperTreeGridEntry
  vtkHyperTreeGridGeometryEntry
  vtkHyperTreeGridGeometryLevelEntry
  vtkHyperTreeGridLevelEntry
  vtkHyperTreeGridNonOrientedCursor
  vtkHyperTreeGridNonOrientedGeometryCursor
  vtkHyperTreeGridNonOrientedMooreSuperCursor
  vtkHyperTreeGridNonOrientedMooreSuperCursorLight
  vtkHyperTreeGridNonOrientedSuperCursor
  vtkHyperTreeGridNonOrientedSuperCursorLight
  vtkHyperTreeGridNonOrientedVonNeumannSuperCursor
  vtkHyperTreeGridNonOrientedVonNeumannSuperCursorLight
  vtkHyperTreeGridOrientedCursor
  vtkHyperTreeGridOrientedGeometryCursor
  vtkImageData
  vtkImageIterator
  vtkImageTransform
  vtkImplicitBoolean
  vtkImplicitDataSet
  vtkImplicitFunction
  vtkImplicitFunctionCollection
  vtkImplicitHalo
  vtkImplicitSelectionLoop
  vtkImplicitSum
  vtkImplicitVolume
  vtkImplicitWindowFunction
  vtkInEdgeIterator
  vtkIncrementalOctreeNode
  vtkIncrementalOctreePointLocator
  vtkIncrementalPointLocator
  vtkInformationQuadratureSchemeDefinitionVectorKey
  vtkIterativeClosestPointTransform
  vtkKdNode
  vtkKdTree
  vtkKdTreePointLocator
  vtkLagrangeCurve
  vtkLagrangeHexahedron
  vtkLagrangeInterpolation
  vtkLagrangeQuadrilateral
  vtkLagrangeTetra
  vtkLagrangeTriangle
  vtkLagrangeWedge
  vtkLine
  vtkLocator
  vtkMarchingCubesTriangleCases
  vtkMarchingSquaresLineCases
  vtkMeanValueCoordinatesInterpolator
  vtkMergePoints
  vtkMolecule
  vtkMultiBlockDataSet
  vtkMultiPieceDataSet
  vtkMutableDirectedGraph
  vtkMutableUndirectedGraph
  vtkNonLinearCell
  vtkNonMergingPointLocator
  vtkOctreePointLocator
  vtkOctreePointLocatorNode
  vtkOrderedTriangulator
  vtkOutEdgeIterator
  vtkPartitionedDataSet
  vtkPartitionedDataSetCollection
  vtkPath
  vtkPentagonalPrism
  vtkPerlinNoise
  vtkPiecewiseFunction
  vtkPixel
  vtkPixelExtent
  vtkPixelTransfer
  vtkPlane
  vtkPlaneCollection
  vtkPlanes
  vtkPlanesIntersection
  vtkPointData
  vtkPointLocator
  vtkPointSet
  vtkPointSetCellIterator
  vtkPointsProjectedHull
  vtkPolyData
  vtkPolyDataCollection
  vtkPolyLine
  vtkPolyPlane
  vtkPolyVertex
  vtkPolygon
  vtkPolyhedron
  vtkPyramid
  vtkQuad
  vtkQuadraticEdge
  vtkQuadraticHexahedron
  vtkQuadraticLinearQuad
  vtkQuadraticLinearWedge
  vtkQuadraticPolygon
  vtkQuadraticPyramid
  vtkQuadraticQuad
  vtkQuadraticTetra
  vtkQuadraticTriangle
  vtkQuadraticWedge
  vtkQuadratureSchemeDefinition
  vtkQuadric
  vtkRectilinearGrid
  vtkReebGraph
  vtkReebGraphSimplificationMetric
  vtkSelection
  vtkSelectionNode
  vtkSimpleCellTessellator
  vtkSmoothErrorMetric
  vtkSortFieldData
  vtkSphere
  vtkSpheres
  vtkSpline
  vtkStaticCellLinks
  vtkStaticCellLocator
  vtkStaticPointLocator
  vtkStaticPointLocator2D
  vtkStructuredData
  vtkStructuredExtent
  vtkStructuredGrid
  vtkStructuredPoints
  vtkStructuredPointsCollection
  vtkSuperquadric
  vtkTable
  vtkTetra
  vtkTree
  vtkTreeBFSIterator
  vtkTreeDFSIterator
  vtkTreeIterator
  vtkTriQuadraticHexahedron
  vtkTriQuadraticPyramid
  vtkTriangle
  vtkTriangleStrip
  vtkUndirectedGraph
  vtkUniformGrid
  vtkUniformHyperTreeGrid
  vtkUnstructuredGrid
  vtkUnstructuredGridBase
  vtkUnstructuredGridCellIterator
  vtkVertex
  vtkVertexListIterator
  vtkVoxel
  vtkWedge
  vtkXMLDataElement

  # New classes for AMR
  vtkAMRDataInternals
  vtkAMRInformation
  vtkNonOverlappingAMR
  vtkOverlappingAMR
  vtkUniformGridAMR
  vtkUniformGridAMRDataIterator)

set(template_classes
  vtkAngularPeriodicDataArray
  vtkArrayListTemplate
  vtkMappedUnstructuredGrid
  vtkMappedUnstructuredGridCellIterator
  vtkPeriodicDataArray
  vtkStaticCellLinksTemplate
  vtkStaticEdgeLocatorTemplate)

set(headers
  vtkCellType.h
  vtkColor.h
  vtkCompositeDataSetNodeReference.h
  vtkCompositeDataSetRange.h
  vtkDataArrayDispatcher.h
  vtkDataAssemblyVisitor.h
  vtkDataObjectTreeInternals.h
  vtkDataObjectTreeRange.h
  vtkDispatcher.h
  vtkDispatcher_Private.h
  vtkDoubleDispatcher.h
  vtkHyperTreeGridScales.h
  vtkHyperTreeGridTools.h
  vtkIntersectionCounter.h
  vtkPolyDataInternals.h
  vtkRect.h
  vtkVector.h
  vtkVectorOperators.h)

set(templates
  vtkCompositeDataSet.txx)

set(private_templates
  vtkImageIterator.txx)

vtk_module_add_module(VTK::CommonDataModel
  CLASSES           ${classes}
  TEMPLATES         ${templates}
  TEMPLATE_CLASSES  ${template_classes}
  HEADERS           ${headers}
  PRIVATE_TEMPLATES ${private_templates})

=== Common/Math/CMakeLists.txt ===
set(classes
  vtkAmoebaMinimizer
  vtkFFT
  vtkFunctionSet
  vtkInitialValueProblemSolver
  vtkMatrix3x3
  vtkMatrix4x4
  vtkPolynomialSolversUnivariate
  vtkQuaternionInterpolator
  vtkRungeKutta2
  vtkRungeKutta4
  vtkRungeKutta45)

set(template_classes
  vtkQuaternion)

set(headers
  vtkTuple.h)

if(CMAKE_COMPILER_IS_GNUCXX)
  set_source_files_properties(vtkPolynomialSolversUnivariate.cxx
    PROPERTIES
      COMPILE_FLAGS -O0)
endif()

vtk_module_add_module(VTK::CommonMath
  CLASSES           ${classes}
  TEMPLATE_CLASSES  ${template_classes}
  HEADERS           ${headers})

=== Common/Misc/CMakeLists.txt ===
set(classes
  vtkContourValues
  vtkErrorCode
  vtkExprTkFunctionParser
  vtkFunctionParser
  vtkHeap
  vtkPolygonBuilder
  vtkResourceFileLocator)

# ExprTk uses lots of templates and exceeds object file limits
if (MINGW)
  set_property(SOURCE vtkExprTkFunctionParser.cxx APPEND
    PROPERTY
      COMPILE_FLAGS "-Wa,-mbig-obj")
endif ()

vtk_module_add_module(VTK::CommonMisc
  CLASSES ${classes})

=== Common/System/CMakeLists.txt ===
vtk_module_find_package(
  PACKAGE Threads)

set(classes
  vtkClientSocket
  vtkDirectory
  vtkExecutableRunner
  vtkServerSocket
  vtkSocket
  vtkSocketCollection
  vtkTimerLog

  # This class is deprecated.
  vtkThreadMessager)

include("${CMAKE_CURRENT_SOURCE_DIR}/vtkTestSocketFeatures.cmake")

set(vtkSocket_defines)
if (VTK_HAVE_GETSOCKNAME_WITH_SOCKLEN_T)
  list(APPEND vtkSocket_defines "VTK_HAVE_GETSOCKNAME_WITH_SOCKLEN_T")
endif ()
if (VTK_HAVE_SO_REUSEADDR)
  list(APPEND vtkSocket_defines "VTK_HAVE_SO_REUSEADDR")
endif ()
if(VTK_NO_PLATFORM_SOCKETS)
  list(APPEND vtkSocket_defines "VTK_SOCKET_FAKE_API")
endif()

set_source_files_properties(vtkSocket.cxx
  PROPERTIES
    COMPILE_DEFINITIONS "${vtkSocket_defines}")

vtk_module_add_module(VTK::CommonSystem
  CLASSES ${classes})
vtk_module_link(VTK::CommonSystem
  PRIVATE
    $<$<PLATFORM_ID:WIN32>:wsock32>
    Threads::Threads)

=== Domains/Chemistry/CMakeLists.txt ===
set(classes
  vtkBlueObeliskData
  vtkBlueObeliskDataParser
  vtkMoleculeMapper
  vtkMoleculeToAtomBallFilter
  vtkMoleculeToBondStickFilter
  vtkMoleculeToLinesFilter
  vtkMoleculeToPolyDataFilter
  vtkPeriodicTable
  vtkPointSetToMoleculeFilter
  vtkProgrammableElectronicData
  vtkProteinRibbonFilter
  vtkSimpleBondPerceiver)

# Generate configured header file
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkChemistryConfigure.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkChemistryConfigure.h"
  @ONLY)

vtk_module_add_module(VTK::DomainsChemistry
  CLASSES ${classes}
  HEADERS "${CMAKE_CURRENT_BINARY_DIR}/vtkChemistryConfigure.h"
  PRIVATE_HEADERS vtkBlueObeliskDataInternal.h)

=== Domains/ChemistryOpenGL2/CMakeLists.txt ===
set(classes
  vtkOpenGLMoleculeMapper
  )

# Now for the object factory.
set(opengl_overrides
  MoleculeMapper
  )

foreach(_override ${opengl_overrides})
  vtk_object_factory_declare(
    BASE vtk${_override}
    OVERRIDE vtkOpenGL${_override})
endforeach()

vtk_object_factory_configure(
  SOURCE_FILE vtk_object_factory_source
  HEADER_FILE vtk_object_factory_header
  EXPORT_MACRO "VTKDOMAINSCHEMISTRYOPENGL2_EXPORT")

vtk_module_add_module(VTK::DomainsChemistryOpenGL2
  CLASSES ${classes}
  SOURCES ${vtk_object_factory_source}
  PRIVATE_HEADERS ${vtk_object_factory_header})

=== Filters/Core/CMakeLists.txt ===
set(classes
  vtk3DLinearGridCrinkleExtractor
  vtk3DLinearGridPlaneCutter
  vtkAppendArcLength
  vtkAppendCompositeDataLeaves
  vtkAppendDataSets
  vtkAppendFilter
  vtkAppendPolyData
  vtkAppendSelection
  vtkArrayCalculator
  vtkAssignAttribute
  vtkAttributeDataToFieldDataFilter
  vtkBinCellDataFilter
  vtkBinnedDecimation
  vtkCellCenters
  vtkCellDataToPointData
  vtkCenterOfMass
  vtkCleanPolyData
  vtkClipPolyData
  vtkCompositeCutter
  vtkCompositeDataProbeFilter
  vtkConnectivityFilter
  vtkContour3DLinearGrid
  vtkContourFilter
  vtkContourGrid
  vtkContourHelper
  vtkConvertToMultiBlockDataSet
  vtkConvertToPartitionedDataSetCollection
  vtkCutter
  vtkDataObjectGenerator
  vtkDataObjectToDataSetFilter
  vtkDataSetEdgeSubdivisionCriterion
  vtkDataSetToDataObjectFilter
  vtkDecimatePolylineFilter
  vtkDecimatePro
  vtkDelaunay2D
  vtkDelaunay3D
  vtkEdgeSubdivisionCriterion
  vtkElevationFilter
  vtkExecutionTimer
  vtkExplicitStructuredGridCrop
  vtkExplicitStructuredGridToUnstructuredGrid
  vtkFeatureEdges
  vtkFieldDataToAttributeDataFilter
  vtkFlyingEdges2D
  vtkFlyingEdges3D
  vtkFlyingEdgesPlaneCutter
  vtkGlyph2D
  vtkGlyph3D
  vtkGridSynchronizedTemplates3D
  vtkHedgeHog
  vtkHull
  vtkIdFilter
  vtkImageAppend
  vtkImageDataToExplicitStructuredGrid
  vtkImplicitPolyDataDistance
  vtkImplicitProjectOnPlaneDistance
  vtkMarchingCubes
  vtkMarchingSquares
  vtkMaskFields
  vtkMaskPoints
  vtkMaskPolyData
  vtkMassProperties
  vtkMergeDataObjectFilter
  vtkMergeFields
  vtkMergeFilter
  vtkMoleculeAppend
  vtkMultiObjectMassProperties
  vtkPassThrough
  vtkPlaneCutter
  vtkPointDataToCellData
  vtkPolyDataConnectivityFilter
  vtkPolyDataEdgeConnectivityFilter
  vtkPolyDataNormals
  vtkPolyDataPlaneClipper
  vtkPolyDataTangents
  vtkProbeFilter
  vtkQuadricClustering
  vtkQuadricDecimation
  vtkRearrangeFields
  vtkRectilinearSynchronizedTemplates
  vtkRemoveDuplicatePolys
  vtkRemoveUnusedPoints
  vtkResampleToImage
  vtkResampleWithDataSet
  vtkReverseSense
  vtkSimpleElevationFilter
  vtkSmoothPolyDataFilter
  vtkSphereTreeFilter
  vtkStaticCleanPolyData
  vtkStreamerBase
  vtkStreamingTessellator
  vtkStripper
  vtkStructuredGridAppend
  vtkStructuredGridOutlineFilter
  vtkSynchronizedTemplates2D
  vtkSynchronizedTemplates3D
  vtkSynchronizedTemplatesCutter3D
  vtkTensorGlyph
  vtkThreshold
  vtkThresholdPoints
  vtkTransposeTable
  vtkTriangleFilter
  vtkTriangleMeshPointNormals
  vtkTubeBender
  vtkTubeFilter
  vtkUnstructuredGridQuadricDecimation
  vtkUnstructuredGridToExplicitStructuredGrid
  vtkVectorDot
  vtkVectorNorm
  vtkVoronoi2D
  vtkWindowedSincPolyDataFilter)

set(headers
    vtk3DLinearGridInternal.h)

vtk_module_add_module(VTK::FiltersCore
  CLASSES ${classes})

=== Filters/Extraction/CMakeLists.txt ===
set(classes
  vtkBlockSelector
  vtkConvertSelection
  vtkExpandMarkedElements
  vtkExtractBlock
  vtkExtractBlockUsingDataAssembly
  vtkExtractCells
  vtkExtractCellsByType
  vtkExtractDataArraysOverTime
  vtkExtractDataOverTime
  vtkExtractDataSets
  vtkExtractEdges
  vtkExtractExodusGlobalTemporalVariables
  vtkExtractGeometry
  vtkExtractGrid
  vtkExtractLevel
  vtkExtractPolyDataGeometry
  vtkExtractRectilinearGrid
  vtkExtractSelectedArraysOverTime
  vtkExtractSelectedBlock
  vtkExtractSelectedIds
  vtkExtractSelectedLocations
  vtkExtractSelectedPolyDataIds
  vtkExtractSelectedRows
  vtkExtractSelectedThresholds
  vtkExtractSelection
  vtkExtractTemporalFieldData
  vtkExtractTensorComponents
  vtkExtractTimeSteps
  vtkExtractUnstructuredGrid
  vtkExtractVectorComponents
  vtkFrustumSelector
  vtkHierarchicalDataExtractDataSets
  vtkHierarchicalDataExtractLevel
  vtkLocationSelector
  vtkProbeSelectedLocations
  vtkSelector
  vtkValueSelector)

vtk_module_add_module(VTK::FiltersExtraction
  CLASSES ${classes})

=== debian/changelog ===
vtk9 (9.1.0+really9.1.0+dfsg2-7deepin1+rb1) unstable; urgency=medium

  * Upload 9.1.0+really9.1.0+dfsg2-7deepin1. Matching debian version
    9.1.0+really9.1.0+dfsg2-7deepin9.

  [ Bo YU ]
  * Team upload.
  * Add support for loongarch64. Thanks to Dandan Zhang
    <zhangdandan@loongson.cn>. (Closes: #1054471)

  [ Michael R. Crusoe ]
  * Cherry-pick patch from upstream to fix issue with newer expat and
    appended data. Closes: #1064762
  * d/control: build-dep on libhdf5-mpi-dev instead of libhdf5-openmpi-
    dev. Closes: #1068321
  * Cherry-pick patch from upstream to fix CVE-2021-42521. Closes:
    #1031877.
  * Fix Maintainer name of Debian Science team (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * d/control: Updated some dependencies on obsolete or supercede packages
    names.

 -- Tianyu Chen <sweetyfish@deepin.org>  Thu, 06 Jun 2024 14:49:37 +0800

vtk9 (9.1.0+really9.1.0+dfsg2-7) unstable; urgency=medium

  * Team upload.
  * Cherry-pick patch from upstream to fix FTBFS with gcc-13.
    (Closes: #1037887)

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 22 Aug 2023 00:27:20 +0200

vtk9 (9.1.0+really9.1.0+dfsg2-6) unstable; urgency=medium

  * Team upload.
  * Don't use netcdf-cxx-legacy.
    (closes: #1038614)

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 22 Jun 2023 07:14:50 +0200

=== debian/control ===
Source: vtk9
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>,
           Gert Wollny <gewo@debian.org>,
           Nico Schlömer <nico.schloemer@gmail.com>
Section: graphics
Priority: optional
Build-Depends: chrpath,
               cmake,
               debhelper-compat (= 13),
               default-jdk [!hppa !hurd-any !kfreebsd-any],
               default-libmysqlclient-dev,
               dh-sequence-python3,
               doxygen-latex,
               ghostscript,
               gnuplot-nox,
               graphviz,
               hdf5-tools,
               dh-sequence-javahelper,
               libalglib-dev,
               javahelper,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libdigest-md5-perl,
               libdouble-conversion-dev,
               libeigen3-dev,
               libexpat-dev,
               libfontconfig-dev | libfontconfig1-dev,
               libfreetype-dev | libfreetype6-dev,
               libftgl-dev,
               libgdal-dev,
               libgl-dev | libgl1-mesa-dev,
               libgl2ps-dev,
               libglvnd-dev,
               libglew-dev,
               libglu1-mesa-dev | libglu-dev,
               libhdf5-mpi-dev,
               libhpdf-dev,
               libjpeg-dev,
               libjs-mathjax,
               libjsoncpp-dev,
               liblz4-dev,
               libmrmpi-dev,
               libnetcdf-dev (>= 1:4.9.0),
               libogg-dev,
               libosmesa6-dev,
               libpng-dev,
               libpq-dev,
               libproj-dev,
               libsqlite3-dev,
               libswscale-dev,
               libtbb-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64 !alpha !ia64],
               libtheora-dev,
               libtiff-dev,
               libutfcpp-dev,
               libx11-dev,
               libxdmf-dev,
               libxml2-dev,
               libxpm-dev,
               libxt-dev,
               lzma,
               mpi-default-dev,
               pkgconf | pkg-config,
               python3-dev,
               python3-matplotlib,
               python3-mpi4py,
               qtbase5-dev,
               libqt5opengl5-dev,
               qtdeclarative5-dev,
               r-base-core,
               r-base-dev,
               r-base,
               tcl-dev,
               texlive-binaries,
               tk-dev,
               x11proto-core-dev,
               xauth,
               xvfb,
               zlib1g-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/vtk9
Vcs-Git: https://salsa.debian.org/science-team/vtk9.git
Homepage: https://www.vtk.org/
Rules-Requires-Root: no

Package: libvtk9-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         default-jdk [!hppa !hurd-any !kfreebsd-any],
         default-libmysqlclient-dev,
         libavcodec-dev,
         libavformat-dev,
         libavutil-dev,
         libc6-dev,
         libdouble-conversion-dev,
         libeigen3-dev,
         libexpat-dev,
         libfreetype-dev | libfreetype6-dev,
         libgdal-dev,
         libgl-dev | libgl1-mesa-dev,
         libgl2ps-dev,
         libglew-dev,
         libglu1-mesa-dev | libglu-dev,
         libhdf5-mpi-dev,
         libjpeg-dev,
         libjsoncpp-dev,
         liblz4-dev,
         libnetcdf-dev,
         libpng-dev,
         libpq-dev,
         libproj-dev,
         libpython3-dev,
         libswscale-dev,
         libtbb-dev [linux-any],
         libtheora-dev,
         libtiff-dev,
         libutfcpp-dev,
         libvtk9.1 (= ${binary:Version}),
         libvtk9-java (= ${binary:Version}) [!hppa !hurd-any !kfreebsd-any],
         libx11-dev,
         libxft-dev,
         libxml2-dev,
         libxss-dev,
         libxt-dev,
         mpi-default-dev,
         python3-vtk9 (= ${binary:Version}),
         tcl-dev,
         tk-dev,
         vtk9 (= ${binary:Version}),
         x11proto-core-dev,
         zlib1g-dev
Suggests: vtk9-doc,
          vtk9-examples
Description: VTK header files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the VTK header files required to compile
 C++ programs that use VTK to do 3D visualisation.

Package: libvtk9.1
Architecture: any
Multi-Arch: same
Section: libs
Breaks: libvtk9 (<< 9.1.0+really9.1.0)
Replaces: libvtk9 (<< 9.1.0+really9.1.0)
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: mpi-default-bin,
          vtk9-doc,
          vtk9-examples
Description: VTK libraries
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries needed to run C++ programs
 that use VTK.

Package: libvtk9-java
Architecture: amd64 arm64 armel armhf i386 loong64 mips64el mipsel ppc64el s390x alpha ia64 m68k powerpc ppc64 riscv64 sh4 sparc64 x32
Section: java
Depends: ${java:Depends},
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: java-virtual-machine,
          libvtk9-dev (= ${binary:Version}),
          vtk9-doc,
          vtk9-examples
Description: VTK - Java language support
 The Visualization Toolkit (VTK) is an object oriented, high level
 library that allows one to easily write C++ programs, Tcl, Python and
 Java scripts that do 3D visualization.
 .
 This package provides the VTK Java language support.

Package: python3-vtk9
Architecture: any
Section: python
Depends: libvtk9.1 (= ${binary:Version}),
         python3-mpi4py,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: mayavi2,
          vtk9-doc,
          vtk9-examples
Breaks: python3-vtk6,
        python3-vtk7
Replaces: python3-vtk6,
          python3-vtk7
Description: Python bindings for VTK
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the python3 bindings for VTK.

Package: vtk9
Architecture: any
Section: interpreters
Depends: libvtk9.1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: vtk9-doc,
          vtk9-examples
Description: Binaries for VTK9
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides binaries for VTK9

Package: vtk9-doc
Architecture: all
Section: doc
Depends: doc-base,
         libjs-jquery,
         libjs-mathjax,
         ${misc:Depends}
Suggests: libvtk9-dev,
          vtk9-examples
Description: VTK class reference documentation
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides documentation for VTK9

Package: vtk9-examples
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: libvtk9-dev,
          python3,
          python3-vtk9,
          vtk9-doc
Description: VTK examples
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides examples for VTK9

Package: libvtk9.1-qt
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: VTK libraries, Qt files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries needed to run C++ programs
 that use VTK. Qt files

Package: libvtk9-qt-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libvtk9-dev (= ${binary:Version}),
         libvtk9.1-qt (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         qtbase5-dev,
         qttools5-private-dev,
         libqt5opengl5-dev,
         libqt5webkit5-dev
Description: VTK header files, containing Qt files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the VTK header files required to compile
 C++ programs that use VTK to do 3D visualisation. Qt files

=== debian/rules ===
#!/usr/bin/make -f
BUILDDIR = $(CURDIR)/debian/build

include /usr/share/dpkg/architecture.mk

nojava_archs=hppa hurd-i386 kfreebsd-i386 kfreebsd-amd64
ifneq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH), $(nojava_archs)))
  export JAVA_HOME=/usr/lib/jvm/default-java
  extra_flags += -DVTK_WRAP_JAVA=ON
endif

ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mips mipsel powerpc sh4))
  export DEB_CXXFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
  export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

notbb_archs=hurd-i386 kfreebsd-i386 kfreebsd-amd64 alpha ia64
ifneq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH), $(notbb_archs)))
  extra_flags += -DVTK_SMP_IMPLEMENTATION_TYPE:STRING="TBB"
else
  extra_flags += -DVTK_SMP_IMPLEMENTATION_TYPE:STRING="OpenMP"
endif

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR)

extra_flags +=  \
	-DBUILD_SHARED_LIBS=ON \
	-DCMAKE_C_COMPILER=mpicc \
	-DCMAKE_CXX_COMPILER=mpic++ \
	-DCMAKE_EXE_LINKER_FLAGS="-Wl,--as-needed -latomic" \
	-DCMAKE_MODULE_LINKER_FLAGS="-Wl,--as-needed" \
	-DCMAKE_SHARED_LINKER_FLAGS="-Wl,--as-needed" \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DHDF5_IS_PARALLEL=OFF \
	-DVTK_BUILD_DOCUMENTATION=ON \
	-DVTK_BUILD_EXAMPLES=OFF \
	-DVTK_BUILD_TESTING=OFF \
	-DVTK_EXTRA_COMPILER_WARNINGS=ON \
	-DVTK_GROUP_ENABLE_Qt:STRING="YES" \
	-DVTK_MODULE_ENABLE_VTK_GUISupportQtSQL:STRING="NO" \
	-DVTK_MODULE_ENABLE_VTK_GUISupportQtQuick:STRING="DONT_WANT" \
	-DVTK_GROUP_ENABLE_Rendering:STRING="YES" \
	-DVTK_GROUP_ENABLE_StandAlone:STRING="YES" \
	-DVTK_GROUP_ENABLE_Views:STRING="YES" \
	-DVTK_GROUP_ENABLE_MPI:STRING="YES" \
	-DVTK_GROUP_ENABLE_Imaging:STRING="YES" \
	-DVTK_MODULE_ENABLE_VTK_RenderingQt:STRING="YES" \
	-DVTK_MODULE_ENABLE_VTK_RenderingTk:STRING="YES" \
	-DVTK_MODULE_ENABLE_VTK_utf8:STRING="YES" \
	-DVTK_MODULE_ENABLE_VTK_InteractionWidgets:STRING="YES" \
	-DVTK_MODULE_ENABLE_VTK_InteractionImage:STRING="YES" \
	-DVTK_MODULE_USE_EXTERNAL_VTK_doubleconversion:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_eigen:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_expat:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_freetype:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_gl2ps:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_glew:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_hdf5:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_jpeg:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_jsoncpp:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_libproj:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_libxml2:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_lz4:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_lzma:BOOL:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_netcdf:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_ogg:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_png:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_sqlite:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_theora:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_tiff:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_utf8:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_zlib:BOOL=ON \
	-DVTK_PYTHON_VERSION:STRING=3 \
	-DVTK_USE_TK=ON \
	-DVTK_WRAP_PYTHON=ON \
	-DVTK_MODULE_ENABLE_VTK_RenderingContextOpenGL2=YES \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DVTK_MODULE_ENABLE_VTK_ParallelMPI:STRING="YES" \
	-DVTK_USE_MPI=ON \
	-DVTK_JAVA_SOURCE_VERSION:STRING=1.8 \
	-DVTK_JAVA_TARGET_VERSION:STRING=1.8 \


override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

execute_after_dh_auto_clean:
	rm -rf $(BUILDDIR)

execute_after_dh_auto_build:
	cd $(BUILDDIR) && make DoxygenDoc
	find $(BUILDDIR)/Utilities/Doxygen/doc/html/ -name "*.md5" | xargs rm -f

override_dh_auto_install:
	dh_auto_install -X.pyc -X.pyo
ifneq ($(JAVA_HOME),)
	# Correct headers for paraview
	mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/java/vtk.jar $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/java/vtk9.jar
endif
	sed -i -e "s/FATAL_ERROR/STATUS/g" $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/vtk-9.1/VTK-targets.cmake

execute_after_dh_install:
	rm -rf $(CURDIR)/debian/tmp/usr/share/licenses
	find $(CURDIR)/debian/libvtk9-dev/ -name "*Qt*" -exec rm {} \; || true
	find $(CURDIR)/debian/libvtk9-dev/ -name "libvtkRenderingPythonTkWidgets.so" -exec rm {} \; || true
	find $(CURDIR)/debian/libvtk9-dev/usr/include/ -name "Q*" -exec rm {} \; || true
	find $(CURDIR)/debian/libvtk9.1/ -name "*Qt*" -exec rm {} \; || true
	find $(CURDIR)/debian/tmp/usr/share/doc/vtk-9.0/doxygen -name "_formulas.log" -exec rm {} \; || true
	find $(CURDIR)/debian/build/Utilities/Doxygen/doc/html -name "_formulas.log" -exec rm {} \; || true

execute_after_dh_installdocs-indep:
	find $(CURDIR)/debian/vtk9-doc/ -type f -print0 | xargs -0 sed -i 's/https:\/\/raw\.githubusercontent\.com//g'
